#define ZKRACENI_Y 0.5
#define ALFA PI/4
#define AX_ALFA PI/6
#define AX_BETA PI/6
#define NECEKANA_CHYBA -1
#define BODU_KRYCHLE 8

typedef enum{FALSE,TRUE}boolean;

typedef enum {
  SHODNE=1,
  ROVNOBEZNE=2,
  MIMOBEZNE=3,
  RUZNOBEZNE=4
  }poloha_primek;

typedef struct
{
  float x;
  float y;
} bod2d;

typedef struct
{
  float x;
  float y;
  float z;
} bod3d;

typedef struct
{
  bod3d A;
  bod3d u;
} primka;

typedef struct
{
  bod3d A;
  bod3d u;
  bod3d v;
  bod3d n;
  float d;
} rovina;

typedef struct
{
  bod3d K;
  bod3d L;
  bod3d M;
  bod3d N;
  bod3d O;
  bod3d P;
  bod3d Q;
  bod3d R;
} krychle;

typedef struct
{
  bod2d K;
  bod2d L;
  bod2d M;
  bod2d N;
  bod2d O;
  bod2d P;
  bod2d Q;
  bod2d R;
} krychle2d;

bod3d operator-(bod3d vektor);
void axonom(bod3d *vstup, bod2d *vystup, int pocet, float alfa, float beta);
bod2d kosouhle(bod3d vstup);
void zvetseni(bod3d *vstup, bod3d *vystup, int pocet, float meritko);
void zvetseni(bod2d *vstup, bod2d *vystup, int pocet, float meritko);
float skal_souc(bod3d v1, bod3d v2);
bod3d operator*(bod3d v1, bod3d v2);
bod3d operator-(bod3d v1, bod3d v2);
bod3d operator+(bod3d v1, bod3d v2);
int primprim(primka p1, primka p2, bod3d *prusecik);
int primrna(primka p,rovina r, bod3d *prusecik);
primka pricka(primka p1, primka p2);
float vzdal_bodu(bod3d A, bod3d B);
float norma(bod3d vektor);
bod3d urci_bod(bod3d X, bod3d vektor, float vzdalenost);
void najdi_krychle(primka p1, primka p2, krychle *krych1, krychle *krych2, krychle *krych3, krychle *krych4);
int zaokrouhli(float f);
krychle2d kosouhle_krychle(krychle vstup);
//int kontrola_primek(primka p1, primka p2, win *roz_ok);
