#include <graphics.h>
#include <stdlib.h>

#include "mys.h"
#include "mat_fce.h"
#include "win_fce.h"
#include "beh_prog.h"

int pocatek_tlacitka[POCET_TLAC]={TRUE,FALSE,TRUE,FALSE,FALSE,FALSE,TRUE,TRUE};
char *text_tlacitka[POCET_TLAC]={"Novy soubor",
				 "Pokracovani souboru",
				 "Klavesnice",
				 "Dalsi reseni",
				 "Predchozi reseni",
				 "Zobrazeni",
				 "Napoveda",
				 "Konec"};

char *chyby[]={"Zadany soubor nema pozadovany format.",
	       "Zadany soubor neobsahuje souradnice 4 bodu.",
	       "Zadane primky jsou shodne. Zadejte nove.",
	       "Zadane primky jsou rovnobezne. Uloha ma nekonecne",
	       "mnoho reseni. Zadejte nove primky.",
	       "Zadane primky se protinaji. Hledan krychle je",
	       "nekonecne mala. Zadejte nove primky.",
	       "Spatne zadane souradnice bodu. Zadejte je znovu.",
	       "Nelze otevrit soubor \"krychle.hlp\".",
	       "Nelze inicializovat grafiku: ",
	       "Soubor nelze otevrit!",
	       "Nedostatek pameti!",
	       "Zadane body jsou stejne. Zadejte jeden jiny.",
	       "Zadane body jedne z primek jsou stejne."};

extern char **texty;


int inic_graf(void)
{
  int gr_driver=DETECT,gmode,gerr;
  int max_x, max_y;

  initgraph(&gr_driver,&gmode,BGI);
  if ( ( gerr=graphresult()) != grOk )
  {
    fprintf(stderr,"%s (%s)\n",chyby[CHYBA_GRAFIKY],grapherrormsg(gerr));
    exit(FALSE);
  }
  else
  {
    max_x=getmaxx();
    max_y=getmaxy();

    setviewport(0,0,max_x,max_y,1);
  }
  return TRUE;
}


void kos_schema(win *roz_ok)
{
  int Ox, Oy;
  float mer;
  viewporttype viewinfo;
  bod2d obraz[]={{0,0},{0,-50},{50,0},{-30,31},{45,-10},{4,-50},{-18,25},{3,-8},{-44,8},{-30,0},{-1,0}};

  smaz_okno(roz_ok,SCH_WIN);
  getviewsettings(&viewinfo);

  setviewport((roz_ok+SCH_WIN)->left,(roz_ok+SCH_WIN)->top,(roz_ok+SCH_WIN)->right,(roz_ok+SCH_WIN)->bottom,1);
  Ox=(roz_ok+SCH_WIN)->x /2;
  Oy=(roz_ok+SCH_WIN)->y /2;
  mer=((roz_ok+SCH_WIN)->x*0.65)/(obraz[2].x-obraz[3].x);

  zvetseni(obraz,obraz,11,mer);
  settextjustify(CENTER_TEXT,CENTER_TEXT);
  settextstyle(SMALL_FONT,HORIZ_DIR,(getmaxy()+1)/STREDNI);
  outtextxy((roz_ok+SCH_WIN)->chx,(roz_ok+SCH_WIN)->chy,"Kosouhle promitani");
  settextjustify(LEFT_TEXT,CENTER_TEXT);
  setcolor(LIGHTGREEN);
  line(Ox+obraz[0].x,Oy+obraz[0].y,Ox+obraz[1].x,Oy+obraz[1].y);
  line(Ox+obraz[0].x,Oy+obraz[0].y,Ox+obraz[2].x,Oy+obraz[2].y);
  line(Ox+obraz[0].x,Oy+obraz[0].y,Ox+obraz[3].x,Oy+obraz[3].y);
  settextstyle(SMALL_FONT,HORIZ_DIR,(getmaxy()+1)/STREDNI);
  outtextxy(Ox+obraz[4].x,Oy+obraz[4].y,"y");
  outtextxy(Ox+obraz[5].x,Oy+obraz[5].y,"z");
  outtextxy(Ox+obraz[6].x,Oy+obraz[6].y,"x*0.5");
  outtextxy(Ox+obraz[7].x,Oy+obraz[7].y,"0");
  setcolor(MAGENTA);
  arc(Ox,Oy,180,225,18);
  line(Ox+obraz[9].x,Oy+obraz[9].y,Ox+obraz[10].x,Oy+obraz[10].y);
  outtextxy(Ox+obraz[8].x,Oy+obraz[8].y,"PI/4");
  setviewport(viewinfo.left,viewinfo.top,viewinfo.right,viewinfo.bottom,viewinfo.clip);
}

void axon_schema(win *roz_ok)
{
  int Ox, Oy;
  float mer;
  viewporttype viewinfo;
  bod2d obraz[]={{0,0},{0,-50},{50,29},{-50,29},{45,-10},{8,-50},{-38,28},{8,-8},{-35,6},{-30,0},{30,0},{18,0},{0,20},{18,11},{10,13},{8,20}};

  smaz_okno(roz_ok,SCH_WIN);
  getviewsettings(&viewinfo);
  setviewport((roz_ok+SCH_WIN)->left,(roz_ok+SCH_WIN)->top,(roz_ok+SCH_WIN)->right,(roz_ok+SCH_WIN)->bottom,1);
  settextjustify(CENTER_TEXT,CENTER_TEXT);
  settextstyle(SMALL_FONT,HORIZ_DIR,(getmaxy()+1)/STREDNI);
  outtextxy((roz_ok+SCH_WIN)->chx,(roz_ok+SCH_WIN)->chy,"Axonometrie");
  Ox=(roz_ok+SCH_WIN)->x /2;
  Oy=(roz_ok+SCH_WIN)->y /2;
  mer=((roz_ok+SCH_WIN)->x*0.75)/(obraz[2].x-obraz[3].x);
  zvetseni(obraz,obraz,16,mer);
  setcolor(MAGENTA);
  arc(Ox,Oy,180,210,obraz[11].x);
  arc(Ox,Oy,330,360,obraz[11].x);
  line(Ox+obraz[9].x,Oy+obraz[9].y,Ox+obraz[10].x,Oy+obraz[10].y);
  outtextxy(Ox+obraz[8].x,Oy+obraz[8].y,"PI/4");
  outtextxy(Ox-obraz[8].x,Oy+obraz[8].y,"PI/4");
  setcolor(LIGHTGREEN);

  line(Ox+obraz[0].x,Oy+obraz[0].y,Ox+obraz[1].x,Oy+obraz[1].y);
  line(Ox+obraz[0].x,Oy+obraz[0].y,Ox+obraz[2].x,Oy+obraz[2].y);
  line(Ox+obraz[0].x,Oy+obraz[0].y,Ox+obraz[3].x,Oy+obraz[3].y);
  settextstyle(SMALL_FONT,HORIZ_DIR,(getmaxy()+1)/STREDNI);
  outtextxy(Ox-obraz[6].x,Oy+obraz[6].y,"y");
  outtextxy(Ox+obraz[5].x,Oy+obraz[5].y,"z");
  outtextxy(Ox+obraz[6].x,Oy+obraz[6].y,"x");
  outtextxy(Ox+obraz[7].x,Oy+obraz[7].y,"0");
  setcolor(LIGHTBLUE);
  line(Ox,Oy,Ox-obraz[13].x,Oy+obraz[13].y);
  line(Ox,Oy,Ox+obraz[13].x,Oy+obraz[13].y);
  line(Ox,Oy,Ox-obraz[12].x,Oy-obraz[12].y);
  outtextxy(Ox+obraz[14].x,Oy+obraz[14].y,"Jx");
  outtextxy(Ox-obraz[14].x,Oy+obraz[14].y,"Jy");
  outtextxy(Ox+obraz[15].x,Oy-obraz[15].y,"Jz");
  setviewport(viewinfo.left,viewinfo.top,viewinfo.right,viewinfo.bottom,viewinfo.clip);
}

int pis_chybu(win *roz_ok,int cislo,int radku)
{
  viewporttype viewinfo;
  int col;
  int max_y=getmaxy();
  int vel_textu=(max_y+1)/STREDNI;
  smaz_okno(roz_ok,T_WIN);
  dis();
  getviewsettings(&viewinfo);
  col=getcolor();
  settextjustify(LEFT_TEXT,CENTER_TEXT);
  settextstyle(SMALL_FONT,HORIZ_DIR,vel_textu);
  setviewport((roz_ok+T_WIN)->left,(roz_ok+T_WIN)->top,(roz_ok+T_WIN)->right,(roz_ok+T_WIN)->bottom,1);
  setcolor(RED);
  settextstyle(SMALL_FONT,HORIZ_DIR,(max_y+1)/STREDNI);
  if(radku==1)
    outtextxy((roz_ok+T_WIN)->chx,(roz_ok+T_WIN)->chy, chyby[cislo]);
  else
    for(int i=0;i<radku;i++)
      outtextxy((roz_ok+T_WIN)->chx,(roz_ok+T_WIN)->chy+vel_textu*3*i, chyby[cislo+i]);
  setcolor(col);
  setviewport(viewinfo.left,viewinfo.top,viewinfo.right,viewinfo.bottom,viewinfo.clip);
  en();
  return cislo;
}

button *zobraz_tlacitka(int x, int y, int *sirka)
{
  int s,i,sir;
  button *tlac;
  int max_y=getmaxy();
  int vel_textu;

  if((tlac = (button *)calloc(POCET_TLAC,sizeof(button)))==NULL)
  {
    printf(chyby[MALO_PAM]);
    exit(FALSE);
  }
  sir=0;
  setpalette(BROWN,BLACK);
  vel_textu=(max_y+1)/STREDNI;
  settextstyle(SMALL_FONT,HORIZ_DIR,vel_textu);
  setfillstyle(SOLID_FILL,LIGHTGRAY);
  settextjustify(CENTER_TEXT,CENTER_TEXT);
  for(i=0;i<POCET_TLAC;i++)
  {
    s=textwidth(text_tlacitka[i]);
    if(s>sir)
      sir=s;
  }
  sir+=textwidth("  ");
  dis();
  for(i=0;i<POCET_TLAC;i++)
  {
     (tlac+i)->stav=pocatek_tlacitka[i];
  /* tlacitka[i][0]=1;*/
     (tlac+i)->left=x - sir;
     (tlac+i)->top=y+i*6*vel_textu;
     (tlac+i)->right=x;
     (tlac+i)->bottom=(tlac+i)->top+4*vel_textu;
     (tlac+i)->sx = (tlac+i)->left + ((tlac+i)->right - (tlac+i)->left)/2;
     (tlac+i)->sy= (tlac+i)->top + ((tlac+i)->bottom-(tlac+i)->top)/2 - 2;
     setcolor(WHITE);
     bar3d((tlac+i)->left,(tlac+i)->top,(tlac+i)->right,(tlac+i)->bottom,0,1);
     if(pocatek_tlacitka[i])
       setcolor(ENABLE_COL);
     else
       setcolor(DISABLE_COL);
     outtextxy((tlac+i)->sx,(tlac+i)->sy,text_tlacitka[i]);
  }
  *sirka=sir;
  en();
  return tlac;
}

void inicializuj_mys()
{
  int j;
  int max_y=getmaxy();
  int max_x=getmaxx();

  reset(&j);
  rangex(0,max_x);
  rangey(0,max_y);
  sensitive(16,16);
  locate(max_x/2, max_y/2);
  en();
}


int stisk_tlac(button *tlac)
{
  int mx,my,i,j;
  stisk(LEVE,&mx,&my);
  do
  {
    while(stisk(LEVE, &mx, &my)==FALSE);
    for(j=0;j<POCET_TLAC;j++)
      if( (tlac+j)->stav && mx>=(tlac+j)->left && mx<=(tlac+j)->right && my>=(tlac+j)->top && my<=(tlac+j)->bottom)
	{
	  return j;
	}
  }while(TRUE);

}

int stisk_tlac2(button *tlac)
{
  int mx,my,j;
  stisk(LEVE,&mx,&my);
  stisk(PRAVE,&mx,&my);
  do
  {
    while(stisk(LEVE, &mx, &my)==FALSE)
      if(stisk(PRAVE,&mx,&my)==TRUE)
	return -1;
    for(j=0;j<POCET_TLAC;j++)
      if( (tlac+j)->stav && mx>=(tlac+j)->left && mx<=(tlac+j)->right && my>=(tlac+j)->top && my<=(tlac+j)->bottom)
	{
	  status(3,&mx,&my);
	  return j;
	}
  }while(TRUE);

}


int stav_tlac(button *tlac, int tlacitko, int novy_stav)
{
  settextjustify(CENTER_TEXT,CENTER_TEXT);
  settextstyle(SMALL_FONT,HORIZ_DIR,(getmaxy()+1)/STREDNI);
  if( (tlac+tlacitko)->stav!=novy_stav)
  {
    dis();
    (tlac+tlacitko)->stav=novy_stav;
    if(novy_stav)
    {
      setcolor(ENABLE_COL);
      outtextxy((tlac+tlacitko)->sx,(tlac+tlacitko)->sy,text_tlacitka[tlacitko]);
    }
    else
    {
      setcolor(DISABLE_COL);
      outtextxy((tlac+tlacitko)->sx,(tlac+tlacitko)->sy,text_tlacitka[tlacitko]);
    }
    en();
    return FALSE;
  }
  else
  {
    return TRUE;
  }
}

win *okna(button **tlac)
{
  int mezera, predel, sirka;
  int max_y=getmaxy();
  int max_x=getmaxx();
  int vel_textu=(max_y+1)/STREDNI;
  win *okna_roz;

  if((okna_roz = (win *)calloc(POCET_OKEN,sizeof(win)))==NULL)
  {
    printf(chyby[MALO_PAM]);
    exit(FALSE);
  }
  mezera=(max_y+1)/POM_MEZ;
  predel=max_y-max_y/4;
  setviewport(0,0,max_x,max_y,1);
  clearviewport();
  *tlac=zobraz_tlacitka(max_x-mezera,mezera,&sirka);
  setbkcolor(BK_COL);
  setcolor(PRED_COL);
  line(max_x-sirka-2*mezera,0,max_x-sirka-2*mezera,max_y);
/**/   line(max_x-sirka-2*mezera,max_y-sirka-2*mezera,max_x,max_y-sirka-2*mezera);
  rectangle(0,0,max_x,max_y);
  line(0,predel,max_x-sirka-2*mezera,predel);
  okna_roz->left=okna_roz->top=(okna_roz+T_WIN)->left=mezera;
  okna_roz->right=(okna_roz+T_WIN)->right=max_x-sirka-3*mezera;
  okna_roz->bottom=predel-mezera;
  (okna_roz+T_WIN)->top=predel+mezera;
  (okna_roz+T_WIN)->bottom=max_y-mezera;
  (okna_roz+SCH_WIN)->left=max_x-sirka-mezera;
  (okna_roz+SCH_WIN)->right=max_x-mezera;
  (okna_roz+SCH_WIN)->top=max_y-sirka-mezera;
  (okna_roz+SCH_WIN)->bottom=max_y-mezera;
  okna_roz->x=okna_roz->right-okna_roz->left;
  okna_roz->y=okna_roz->bottom-okna_roz->top;
  (okna_roz+T_WIN)->x=(okna_roz+T_WIN)->right-(okna_roz+T_WIN)->left;
  (okna_roz+T_WIN)->y=(okna_roz+T_WIN)->bottom-(okna_roz+T_WIN)->top;
  (okna_roz+SCH_WIN)->x=(okna_roz+SCH_WIN)->right-(okna_roz+SCH_WIN)->left;
  (okna_roz+SCH_WIN)->y=(okna_roz+SCH_WIN)->bottom-(okna_roz+SCH_WIN)->top;
  setcolor(PRED_COL);
  setfillstyle(SOLID_FILL,WIN_COL);
  dis();
  bar3d(okna_roz->left,okna_roz->top,okna_roz->right,okna_roz->bottom,0,1);
  bar3d((okna_roz+T_WIN)->left,(okna_roz+T_WIN)->top,(okna_roz+T_WIN)->right,(okna_roz+T_WIN)->bottom,0,1);
  bar3d((okna_roz+SCH_WIN)->left,(okna_roz+SCH_WIN)->top,(okna_roz+SCH_WIN)->right,(okna_roz+SCH_WIN)->bottom,0,1);
  en();
  okna_roz->chx=(okna_roz+T_WIN)->left+mezera;
  okna_roz->chy=(okna_roz+T_WIN)->top+vel_textu*3;
  (okna_roz+T_WIN)->chx = okna_roz->chx - (okna_roz+T_WIN)->left;
  (okna_roz+T_WIN)->chy = okna_roz->chy - (okna_roz+T_WIN)->top;
  (okna_roz+SCH_WIN)->chx=(okna_roz+SCH_WIN)->x / 2;
  (okna_roz+SCH_WIN)->chy=(okna_roz+SCH_WIN)->y - mezera;

  settextjustify(LEFT_TEXT,CENTER_TEXT);
  settextstyle(SMALL_FONT,HORIZ_DIR,(max_y+1)/MALE);
  setcolor(ENABLE_COL);
  outtextxy(mezera*5,mezera/2-1,texty[NAZEV]);
  return okna_roz;
}


void smaz_okno(win *roz_ok, int cislo)
{
  viewporttype viewinfo;

  getviewsettings(&viewinfo);
  setviewport((roz_ok+cislo)->left,(roz_ok+cislo)->top,(roz_ok+cislo)->right,(roz_ok+cislo)->bottom,1);
  setfillstyle(SOLID_FILL,WIN_COL);
//  clearviewport();
  dis();
  setcolor(PRED_COL);
  bar3d(0,0,(roz_ok+cislo)->x,(roz_ok+cislo)->y,0,1);
  setviewport(viewinfo.left,viewinfo.top,viewinfo.right,viewinfo.bottom,viewinfo.clip);
  en();
}

void nastav_tlac(button *tlac, int *stavy)
{
  int i;
  if(stavy==NULL)
    for(i=0;i<POCET_TLAC;i++)
      stav_tlac(tlac,i,FALSE);
  else
    for(i=0;i<POCET_TLAC;i++)
      stav_tlac(tlac,i,stavy[i]);
}


